#include "ReflectanceMap.h"

unsigned char DCT_temp2[BLOCK_SIZEY][BLOCK_SIZEX];
 
/*
void LDR_ReflectanceMapArray::CalculateEnvironment(floatimage &environment)
{
	// calculate env_dct
	env_dct.copy(environment);
	
	// scale based on phi
	for (int y = 0; y < max_phi; y++)
	{
		float phiscale = sin((y + 0.5) * 3.14159265358979323 / max_phi);

		for (int x = 0; x < max_theta; x++)
		{
			env_dct.line[y][x] *= phiscale;
		}
	}

	::DCT(env_dct);
	::ZigZag(env_dct);

	// convert env_dct to integers
	for (y = 0; y < max_phi; y++)
	{
		for (int x = 0; x < max_theta; x++)
		{
			env_dct_int[0][y * max_theta + x] = (int) env_dct.line[y][x].r;
			env_dct_int[1][y * max_theta + x] = (int) env_dct.line[y][x].g;
			env_dct_int[2][y * max_theta + x] = (int) env_dct.line[y][x].b;
		}
	}
}


int LDR_ReflectanceMapArray::StartCalculation(floatimage &environment, int cur, int max)
{	
	mutex_lock(&thread_state_mutex);
	if (thread_state)					// some threads still calculating
	{
		mutex_unlock(&thread_state_mutex);
		return 0;
	}
	
	if (cur == 0)		// recalculate environment DCT and RLE
	{
		CalculateEnvironment(environment);
		left = 0;
		right = sizex - 1;
	}
	else
	{
		left  = (int) (((float) cur + 0) * (sizex) / max);
		right = (int) (((float) cur + 1) * (sizex) / max) - 1;
	}

	thread_state = (1 << thread_count) - 1;
	mutex_unlock(&thread_state_mutex);
	cond_broadcast(&start_calculation_signal);

	return 1;
}

		
void LDR_ReflectanceMapArray::calculateLines(int start, int end)
{
	for (int y = start; y <= end; y++)
	{
		for (int x = left; x <= right; x++)
		{
			finished_img.line[y][x].rgbRed =	
				computePixelChannel((char *) redRLE(x, y), env_dct_int[0], max_phi * max_theta);

			finished_img.line[y][x].rgbGreen =
				computePixelChannel((char *) greenRLE(x, y), env_dct_int[1], max_phi * max_theta);

			finished_img.line[y][x].rgbBlue =
				computePixelChannel((char *) blueRLE(x, y), env_dct_int[2], max_phi * max_theta);
		}
	}
}


unsigned char LDR_ReflectanceMapArray::computePixelChannel(char *rle, int *mult, int count)
{
	int sum = 0;
	int *max = &mult[count];

	char temp = 0;

	int c = count / (BLOCK_SIZEX * BLOCK_SIZEY);		// number of DC components;

	while (c)											// sum DC components
	{
		sum += ((unsigned char) *rle++) * (*mult++);
		c--;
	}

	while (mult < max)									// sum RLE AC components
	{
		int nzcount = (unsigned char) *rle++;

		while (nzcount)
		{
			sum += (*rle++) * (*mult++);
			nzcount--;
		};	
	
		if (mult >= max)
			break;
	
		mult += (unsigned char) (*rle++);
	}

	sum >>= exposure;

	return (sum < 0 ? 0 : sum > 4096 ? 255 : linear_to_gamma_table[sum]);
}
*/

int LDR_ReflectanceMapArray::SaveMonsta(const char *name)
{
	int x;
	FILE *outfile = fopen(name, "wb");

	if (!outfile)
		return 0;

	fwrite(&max_theta, sizeof(int), 1, outfile);
	fwrite(&max_phi, sizeof(int), 1, outfile);
	fwrite(&sizex, sizeof(int), 1, outfile);
	fwrite(&sizey, sizeof(int), 1, outfile);
	fwrite(&RLEbytes, sizeof(int), 1, outfile);
	for (x = 0; x < sizex * sizey * 3; x++)
	{
	  if (RLEindex[x])
	    RLEindex[x] = (char *) (RLEindex[x] - RLEbuf);
	  else
	    RLEindex[x] = (char *) -1;
	}

	fwrite(RLEindex, sizeof(char *), sizex * sizey * 3, outfile);

	for (x = 0; x < sizex * sizey * 3; x++)
	{
	  if (RLEindex[x] != (char*) -1)
	    RLEindex[x] += (int) RLEbuf;
	  else
	    RLEindex[x] = NULL;
	}

	fwrite(RLEbuf, sizeof(char), RLEbytes, outfile);
	
	fclose(outfile);
	return 1;
}


int LDR_ReflectanceMapArray::LoadMonsta(const char *name)
{
	int x;
	FILE *infile = fopen(name, "rb");

	if (!infile)
		return 0;

	Release();

	fread(&max_theta, sizeof(int), 1, infile);
	fread(&max_phi, sizeof(int), 1, infile);
	fread(&sizex, sizeof(int), 1, infile);
	fread(&sizey, sizeof(int), 1, infile);
	fread(&RLEbytes, sizeof(int), 1, infile);

	RLEindex = new char *[sizex * sizey * 3];
	RLEbuf = new char[RLEbytes];

	fread(RLEindex, sizeof(char *), sizex * sizey * 3, infile);

	for (x = 0; x < sizex * sizey * 3; x++)
	{
	  if(RLEindex[x] != (char*) -1)
	    RLEindex[x] += (int) RLEbuf;
	  else
	    RLEindex[x] = NULL;
	}

	fread(RLEbuf, sizeof(char), RLEbytes, infile);

/*	finished_img.Allocate(sizex, sizey);
	env_dct_int[0] = new int [max_phi * max_theta];
	env_dct_int[1] = new int [max_phi * max_theta];
	env_dct_int[2] = new int [max_phi * max_theta];
*/

	chan_size = max_phi * max_theta;
	RM_size = chan_size * 3;
	DC_count = chan_size / (BLOCK_SIZEX * BLOCK_SIZEY);

	fclose(infile);
	return 1;
}


int LDR_ReflectanceMapArray::RLE_compress_RM(unsigned char *source, char *ACdest)			// returns number of bytes written to dest
{
	// compress max_phi * max_theta bytes starting at source into dest
	ZigZag_RM(source);		// zig zag re-order the DCT blocks of the reflectance map
			
	char *start = ACdest;
	unsigned char *max = &source[max_phi * max_theta];

	memcpy(ACdest, source, DC_count);	// copy DC components straight across
	source += DC_count;
	ACdest += DC_count;

	while (source < max)
	{
		int nzcount = 0;
		while ((&source[nzcount] < max) && (source[nzcount] != 0) && (nzcount < 255))
			nzcount++;
		*ACdest++ = nzcount;
		memcpy(ACdest, source, nzcount);
		source += nzcount;
		ACdest += nzcount;

		if (source >= max)
		  {
		    *ACdest++ = 0;
		    break;
		  }

		int zcount = 0;
		while ((&source[nzcount] < max) && (source[zcount] == 0) && (zcount < 255))
			zcount++;
		*ACdest++ = zcount;
		source += zcount;
	}

	return (ACdest - start);
}


float LDR_ReflectanceMapArray::RLE_compress(float *progress, image *img)
{
	if (!RLEbuf)
		RLEbuf = new char[RM_size * sizex * sizey];
	if (!RLEindex)
		RLEindex = new char *[sizex * sizey * 3];
	if (!RMtemp)
		RMtemp = new unsigned char[RM_size];				// temp RM buf

	int count = 0;
	int max = sizex * sizey;
	char *cur = RLEbuf;
	for (int y = 0; y < sizey; y++)
	{
		for (int x = 0; x < sizex; x++)
		{
		  if ((!img) || (img->line[y][x].rgbRed))
		    {
		      RLEindex[0 * sizex * sizey + y * sizex + x] = cur;
		      cur += RLE_compress_RM(redRM(x, y), cur);
		      RLEindex[1 * sizex * sizey + y * sizex + x] = cur;
		      cur += RLE_compress_RM(greenRM(x, y), cur);
		      RLEindex[2 * sizex * sizey + y * sizex + x] = cur;
		      cur += RLE_compress_RM(blueRM(x, y), cur);
		      if (cur - RLEbuf > RM_size * sizex * sizey) // not enough memory allocated (compression failed)
			return 0.0;
		    }
		  else // encode all black!
		    {
		      RLEindex[0 * sizex * sizey + y * sizex + x] = NULL;
		      RLEindex[1 * sizex * sizey + y * sizex + x] = NULL;
		      RLEindex[2 * sizex * sizey + y * sizex + x] = NULL;
		    }
		  
		  if (progress)
		    *progress = count / (float) max;
		  count++;
		}
	}

	RLEbytes = cur - RLEbuf;
	return (RLEbytes / (RM_size * sizex * sizey + 0.0));
}


void LDR_ReflectanceMapArray::ZigZag_RM(unsigned char *source)		// apply zig-zag transformation to the reflectance map starting at source
{
	memcpy(RMtemp, source, chan_size);

	int cur = 0;
	for (int by = 0; by < max_phi / BLOCK_SIZEY; by++)
	{
		for (int bx = 0; bx < max_theta / BLOCK_SIZEX; bx++)
		{
			int i = 0;
			for (int y = 0; y < BLOCK_SIZEY; y++)
			{
				for (int x = 0; x < BLOCK_SIZEX; x++)
				{
					int ax = bx * BLOCK_SIZEX + x;
					int ay = by * BLOCK_SIZEY + y;
					source[cur + zigzag[i]] = RMtemp[ay * max_theta + ax];
					i++;
				}
			}
			cur += BLOCK_SIZEX * BLOCK_SIZEY;
		}
	}

	// SWAP THE DC COMPONENTS TO THE FIRST 8 BYTES OF THE REFLECTANCE MAP DATA - hack alert

	cur = 1;			
	for (int x = BLOCK_SIZEX * BLOCK_SIZEY; x < chan_size; x += BLOCK_SIZEX * BLOCK_SIZEY)
	{
		unsigned char temp = source[cur];
		source[cur] = source[x];
		source[x] = temp;
		cur++;
	}
}

		
void LDR_ReflectanceMapArray::UnZigZag_RM(unsigned char *source)
{
	memcpy(RMtemp, source, chan_size);

	int cur = 0;
	for (int by = 0; by < max_phi / BLOCK_SIZEY; by++)
	{
		for (int bx = 0; bx < max_theta / BLOCK_SIZEX; bx++)
		{
			int i = 0;
			for (int y = 0; y < BLOCK_SIZEY; y++)
			{
				for (int x = 0; x < BLOCK_SIZEX; x++)
				{
					int ax = bx * BLOCK_SIZEX + x;
					int ay = by * BLOCK_SIZEY + y;
					source[ay * max_theta + ax] = RMtemp[cur + zigzag[i]];
					i++;
				}
			}
			cur += BLOCK_SIZEX * BLOCK_SIZEY;
		}
	}
}


void LDR_ReflectanceMapArray::IDCT_Block(char *rm, int u0, int v0)
{
	unsigned int u,v,i,j;
	float sum;

	for (v = 0; v < BLOCK_SIZEY; v++)
	{
		memcpy(DCT_temp2[v], &rm[(v0 + v) * max_theta + u0], BLOCK_SIZEX);
	}

	for (v = 0; v < BLOCK_SIZEY; v++) 
	{
		for (u = 0; u < BLOCK_SIZEX; u++) 
		{
			sum = 0.0f;
			for (j = 0; j < BLOCK_SIZEY; j++) 
			{
				for (i = 0; i < BLOCK_SIZEX; i++) 
				{
					float m = IDCT_bases[u][i] * IDCT_bases[v][j];
					sum += (* (char *) &DCT_temp2[j][i]) * m;
				}
			}

			sum *= 0.25f;
			rm[(v0 + v) * max_theta + u0 + u] = (char) (sum < 0 ? 0 : sum > 255 ? 255 : sum);
		}
	}
}


void LDR_ReflectanceMapArray::DCT_Block(unsigned char *rm, int u0, int v0, float quality)
{
	unsigned int u,v,i,j;
	float sum;

	for (v = 0; v < BLOCK_SIZEY; v++)
	{
		memcpy(DCT_temp2[v], &rm[(v0 + v) * max_theta + u0], BLOCK_SIZEX);
	}

	float av = 0.7071f;
	for (v = 0; v < BLOCK_SIZEY; v++) 
	{
		for (u = 0; u < BLOCK_SIZEX; u++) 
		{
			sum = 0.0f;
			for (j = 0; j < BLOCK_SIZEY; j++) 
			{
				for (i = 0; i < BLOCK_SIZEX; i++) 
				{
					float m = DCT_bases[i][u] * DCT_bases[j][v];
					sum += DCT_temp2[j][i] * m;
				}
			}
			sum *= 0.25f * 0.66f * av * ((u==0) ? 0.7071f : 1.f);

			sum = (fabs(sum) <= DCT_threshold[v][u] / quality ? 0.0f : sum);

			if (sum < -128)
			{
				if ((u != 0) || (v != 0))
				{
					sum = -128;
				}
			}

			if (sum > 127)
			{
				if ((u != 0) || (v != 0))
				{
					sum = 127;
				}
			}

			rm[(v0 + v) * max_theta + u0 + u] = (unsigned char) sum;
		}
		av = 1.0f;
	}
}
