// BMP.CPP - Reading and writing Microsoft BMP headers

#include <stdlib.h>
#include <stdio.h>

#include "bmp.h"


int ReadHeader(FILE *infile, BITMAPINFOHEADER *i)
{
  BITMAPFILEHEADER head;
	
  if ((infile == NULL) || (i == NULL)) return 0;

  if (fread(&head, sizeof(BITMAPFILEHEADER), 1, infile) != 1) return 0;
  if (fread(i, sizeof(BITMAPINFOHEADER), 1, infile) != 1) return 0;

  if (i->biBitCount == 8)
	  fseek(infile, 256 * sizeof(RGBQUAD), SEEK_CUR);
  
  return 1;
}


int WriteHeader(BITMAPINFOHEADER *i, FILE *outfile)
{
	BITMAPFILEHEADER bmfh;

	bmfh.bfType = *((WORD *) "BM");
	bmfh.bfOffBits = 0x36;

	if (i->biBitCount == 8)
		bmfh.bfOffBits += 256 * sizeof(RGBQUAD);
	bmfh.bfSize = bmfh.bfOffBits + i->biWidth * i->biHeight * (i->biBitCount/8);
	bmfh.bfReserved1 = 0;
	bmfh.bfReserved2 = 0;

#define WRITE(what) { if(fwrite(&(what), sizeof(what), 1, outfile) != 1) return 0; }

	WRITE(bmfh.bfType);
	WRITE(bmfh.bfSize);
	WRITE(bmfh.bfReserved1);
	WRITE(bmfh.bfReserved2);
	WRITE(bmfh.bfOffBits);

	WRITE(i->biSize);
	WRITE(i->biWidth);
	WRITE(i->biHeight);
	WRITE(i->biPlanes);
	WRITE(i->biBitCount);
	WRITE(i->biCompression);
	WRITE(i->biSizeImage);
	WRITE(i->biXPelsPerMeter);
	WRITE(i->biYPelsPerMeter);
	WRITE(i->biClrUsed);
	WRITE(i->biClrImportant);

	if (i->biBitCount == 8)
		if (fwrite(&i[1], 256 * sizeof(RGBQUAD), 1, outfile) != 1) 
		  return 0;

	return 1;
}

