#ifndef __BMP_H
#define __BMP_H

#ifdef _WIN32
#include <windows.h>
#else

typedef unsigned char       BYTE;
typedef long unsigned int   DWORD;
typedef long                LONG;
typedef unsigned short      WORD;

typedef struct 
{
  BYTE    rgbBlue;
  BYTE    rgbGreen;
  BYTE    rgbRed;
  BYTE    rgbReserved;
} RGBQUAD; 

typedef struct 
{
  WORD    bfType; 
  DWORD   bfSize;
  WORD    bfReserved1;
  WORD    bfReserved2;
  DWORD   bfOffBits;
} BITMAPFILEHEADER;

#define BI_RGB 0

typedef struct
{
  DWORD  biSize; 
  LONG   biWidth;
  LONG   biHeight;
  WORD   biPlanes;
  WORD   biBitCount;
  DWORD  biCompression;
  DWORD  biSizeImage;
  LONG   biXPelsPerMeter;
  LONG   biYPelsPerMeter;
  DWORD  biClrUsed; 
  DWORD  biClrImportant;
} BITMAPINFOHEADER;

#endif // not defined(_WIN32)


#ifdef IMAGE_RGB
typedef struct {
  unsigned char rgbBlue, rgbGreen, rgbRed;
} RGB;
#else
typedef struct {
  unsigned char rgbRed, rgbGreen, rgbBlue;
} RGB;
#endif


#include <stdio.h>

int ReadHeader(FILE *infile, BITMAPINFOHEADER *i);
int WriteHeader(BITMAPINFOHEADER *i, FILE *outfile);

#endif
