#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  FILE *f;

  unsigned char in[16][16];
  unsigned char out[16][2];

  int line, i;

  if(argc != 2)
    return -1;

  f = fopen(argv[1], "rb");
  if(!f) return -2;

  fread((unsigned char*) in, 16, 16, f);
  fclose(f);

  printf("unsigned char mask[] = {\n");

  for(line = 0; line < 16; line++) {

    out[line][0] = 0;
    out[line][1] = 0;

    for(i = 0; i < 16; i++) {
 
      if(in[line][i] != 1)
	out[line][i / 8] += 1 << (i % 8);
    }

    printf("\t0x%02x, 0x%02x,\n", out[line][1], out[line][0]);
  }

  printf(" };\n\n");

   printf("unsigned char data[] = {\n");

  for(line = 0; line < 16; line++) {

    out[line][0] = 0;
    out[line][1] = 0;

    for(i = 0; i < 16; i++) {
 
      if(in[line][i] == 0)
	out[line][i / 8] += 1 << (i % 8);
    }

    printf("\t0x%02x, 0x%02x,\n", out[line][1], out[line][0]);
  }

  printf(" };\n\n");

  
}
